-- testbench che produce potenziali hazard in uscita a gate or 
-- con diversi modelli di ritardo 
library IEEE;
use IEEE.std_logic_1164.all;

entity tb is 
end entity; 

architecture behav of tb is 
signal x,y,out_inert,out_transp,out_inert_r: std_logic; 

begin 
  g0: entity work.or2(inertial_delay) generic map (t=>10 ns, tr=>5 ns) 
      port map(a=>x,b=>y,output=>out_inert); 
  g1: entity work.or2(transport_delay) generic map (t=>10 ns, tr=>5 ns) 
      port map(a=>x,b=>y,output=>out_transp);   
  g2: entity work.or2(inertial_delay_r) generic map (t=>10 ns, tr=>5 ns) 
      port map(a=>x,b=>y,output=>out_inert_r); 
      
  p0: process
      begin 
        wait for 2 ns; 
        x <= '0'; 
        y <= '1'; 
        wait for 12 ns; 
        y <= '0'; 
        -- gli ingressi rimangono entrambi a 0 per 8 ns
        wait for 8 ns; 
        x <= '1'; 
        wait for 10 ns;
        x <= '0'; 
        -- gli ingressi rimangono entrambi a 0 per 4 ns 
        wait for 4 ns; 
        y <= '1';
        end process;
end architecture; 
      
